/*
 * segment.h
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef segment_h
#define segment_h


#include"types.h"
#include"config.h"


#define	KERNEL_CODE_DES 0x8				/* ͥ륳ɥǥץ */
#define	KERNEL_DATA_DES 0x10			/* ͥǡǥץ */
#define	USER_CODE_DES 0x1b				/* 桼ɥǥץ */
#define	USER_DATA_DES 0x23				/* 桼ǡǥץ */
#define	TSS_DES 0x28					/* TSSǥץ */
#define GATE_DES (TSS_DES+MAX_CPU*8)	/* value of Call gate discriptor */
#define GDT_ENTRY 256					/* GDȥ꡼ */


#ifndef ASM_FILE


/* ǥץ¤ */
typedef struct{
	uint low;
	uint high;
}DESCRIPTOR;

/* ǥץơ֥쥸¤ */
typedef struct{
	ushort num;
	DESCRIPTOR *des __attribute__((packed));
}DTR;


enum{
	TYPE_KERNEL_CODE=0xc09a00,		/* ͥ륳ɥǥץѥץե饰 */
	TYPE_KERNEL_DATA=0xc09200,		/* ͥ륳ɥǥץѥץե饰 */
	TYPE_USER_CODE=0xc0fa00,		/* 桼ɥǥץѥץե饰 */
	TYPE_USER_DATA=0xc0f200,		/* 桼ɥǥץѥץե饰 */
	TYPE_TSS=0x8900					/* TSSѥץե饰 */
};


extern DTR gdtr;
extern DESCRIPTOR gdt[];

extern void set_user_desculiptor();
extern void set_gdt(int,void*,uint,int);


#endif


#endif
